"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GMContext = void 0;
const axios_1 = __importDefault(require("axios"));
const tough_cookie_1 = require("tough-cookie");
const values_1 = require("../storage/values");
class GMContext {
    constructor(logger, jar, values) {
        this.logger = logger;
        this.cookiejar = jar || new tough_cookie_1.CookieJar();
        this.values = values || new values_1.ModelValues([]);
    }
    static Function() {
        return (target, propertyName, descriptor) => {
            GMContext.gmFuncMap[propertyName] = descriptor.value;
        };
    }
    GmFunc(name) {
        return GMContext.gmFuncMap[name];
    }
    GM_xmlhttpRequest(detail) {
        let respType = detail.responseType;
        if (detail.responseType == 'json') {
            respType = 'text';
        }
        const config = {
            url: detail.url,
            method: detail.method || 'GET',
            headers: detail.headers || {},
            data: detail.data,
            timeout: detail.timeout,
            responseType: respType,
            maxRedirects: detail.maxRedirects,
        };
        // 处理cookie
        for (const key in config.headers) {
            if (key.toLowerCase() == 'cookie') {
                detail.cookie = config.headers[key];
                delete config.headers[key];
            }
        }
        if (!detail.anonymous) {
            const cookieStr = this.cookiejar.getCookieStringSync(detail.url);
            if (cookieStr) {
                config.headers['cookie'] = cookieStr;
            }
        }
        if (detail.cookie) {
            config.headers['cookie'] =
                (config.headers['cookie'] ? config.headers['cookie'] + ';' : '') + detail.cookie;
        }
        void axios_1.default
            .request(config)
            .then((resp) => {
            // 处理set-header
            if (resp.headers['set-cookie']) {
                this.logger.debug('jar set-cookie', detail.url, resp.headers['set-cookie']);
                for (let i = 0; i < resp.headers['set-cookie'].length; i++) {
                    this.cookiejar.setCookieSync(resp.headers['set-cookie'][i], detail.url);
                }
            }
            if (detail.onload) {
                let headers = '';
                for (const key in resp.headers) {
                    if (typeof resp.headers[key] == 'string') {
                        headers += `${key}: ${resp.headers[key]}\n`;
                    }
                    else {
                        for (let i = 0; i < resp.headers[key].length; i++) {
                            headers += `${key}: ${resp.headers[key][i]}\n`;
                        }
                    }
                }
                // 根据gm的规则去处理response,以求兼容
                let respText = undefined;
                let response = undefined;
                switch (detail.responseType) {
                    case 'json':
                        try {
                            if (typeof resp.data == 'object') {
                                response = resp.data;
                                respText = JSON.stringify(resp.data);
                            }
                            else {
                                respText = resp.data;
                                response = resp.data;
                            }
                        }
                        catch (e) { }
                        break;
                    case undefined:
                        // 默认传文本
                        try {
                            if (typeof resp.data == 'object') {
                                respText = JSON.stringify(resp.data);
                            }
                            else {
                                respText = resp.data;
                            }
                            response = respText;
                        }
                        catch (e) { }
                        break;
                }
                const req = resp.request;
                detail.onload({
                    finalUrl: req.res.responseUrl,
                    responseHeaders: headers,
                    status: resp.status,
                    statusText: resp.statusText,
                    response: response,
                    responseText: respText,
                    responseType: detail.responseType,
                });
            }
        })
            .catch((e) => {
            this.logger.error('GM_xmlhttpRequest', detail.url, e);
            detail.onerror && detail.onerror('');
        });
    }
    GM_notification(detail) {
        this.logger.info('GM_notification', detail);
    }
    GM_log(level, log) {
        if (arguments.length == 1) {
            this.logger.info('GM_log', 'info', log);
        }
        else {
            this.logger.info('GM_log', level, log);
        }
    }
    GM_getValue(key, defaultVal) {
        return this.values.getValue(key, defaultVal);
    }
}
GMContext.gmFuncMap = {};
__decorate([
    GMContext.Function()
], GMContext.prototype, "GM_xmlhttpRequest", null);
__decorate([
    GMContext.Function()
], GMContext.prototype, "GM_notification", null);
__decorate([
    GMContext.Function()
], GMContext.prototype, "GM_log", null);
__decorate([
    GMContext.Function()
], GMContext.prototype, "GM_getValue", null);
exports.GMContext = GMContext;
